/////////1/////////2/////////3/////////4/////////5/////////6/////////7/////////8
// tree_oarchive_impl.ipp:

// (C) Copyright 2002 Robert Ramey - http://www.rrsd.com .
// (C) Copyright 2006 Janek Kozicki - http://janek.kozicki.pl .
// Distributed under the Boost Software License, Version 1.0. (See
// accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

//  See http://www.boost.org for updates, documentation, and revision history.

#include <string>
#include <boost/config.hpp>
#include <locale>
#include <cstddef> // size_t

#include <boost/config.hpp>
#if defined(BOOST_NO_STDC_NAMESPACE)
namespace std{ 
    using ::size_t; 
} // namespace std
#endif

#ifndef BOOST_NO_CWCHAR
#include <cwchar>
#ifdef BOOST_NO_STDC_NAMESPACE
namespace std{ using ::wcslen; }
#endif
#endif

//#include <boost/archive/tree_oarchive.hpp>

namespace boost { 
namespace archive {

//////////////////////////////////////////////////////////////////////
// implementation of basic_text_oprimitive overrides for the combination
// of template parameters used to create a boost_archive_tree_node

#ifndef BOOST_NO_CWCHAR

/// ...

#endif // BOOST_NO_CWCHAR

template<class Archive>
BOOST_ARCHIVE_DECL(BOOST_PP_EMPTY()) 
tree_oarchive_impl<Archive>::tree_oarchive_impl(
    boost_archive_tree<char_type> & td,
    unsigned int flags
) : 
    basic_text_oprimitive<stream_type>(
        td.m_ss,
        0 != (flags & no_codecvt)
    ),
    basic_tree_oarchive<Archive>(flags),
    m_tree_node(NULL),
    m_tree(td)
{
}

/*
template<class Archive>
BOOST_ARCHIVE_DECL(void)
tree_oarchive_impl<Archive>::save_binary(const void *address, std::size_t count){
    #if ! defined(__MWERKS__)
    this->basic_text_oprimitive<stream_type>::save_binary
    #else
    this->basic_text_oprimitive::save_binary
    #endif
    (
        address, 
        count
    );
}
*/
} // namespace archive
} // namespace boost


